*******************************************************************************
* Routine for USR0 to test CPU type
* Call from BASIC with:                                                       *
* CLEAR 200,&H3EFF                                                            *
* LOADM"CPUTYPE"
* EXEC
* A=USR0(0)                                                             *
*******************************************************************************
*Copyright (C) 2016 Barry Nelson
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*
        ORG   $B0
USRPTR  RMB   2
        ORG   $3F00
USR0    LDD   #$FFFF make sure D is non-zero
        FDB   $104F  (CLRD) execs as pseudo-NOP ($10), and CLRA on 6809
        TSTB         is this a 6309?
        BNE   IS6809 no, return 0 and exit
        LDD   #1
        JMP   $B4F4  Return result and exit
IS6809  LDD   #0
        JMP   $B4F4  Return result and exit
SETUP   PSHS  X,Y
        LDX   USRPTR Address of USR table
        LEAY  USR0,PCR
        STY   ,X     DEFUSR0
        PULS  X,Y
        RTS
        END   SETUP
